/*
 *	G	v
 *
 *		gp{[h
 *			ADM-001: PIC 16F627A
 *			ADM-203: 7SEGMENT LED
 *			ADM-101: PUSH SWITCH
 *
 *		ڑ
 *			ADM-001				ADM-203
 *			RB0					P4
 *			RB1					P3
 *			RB2					P2
 *			RB3					P1
 *			RB4					P5
 *			RB5					P6
 *			RB6					P7
 *			RB7					P8
 *
 *			ADM-001				ADM-101
 *			RA0					P1
 *			RA1					P2
 *			RA2					P3
 *
 *							2009N1001
 */


/*
	CN[h
 */
#include <pic.h>


/*
	RtBM[V[h̐ݒ
 */
//__CONFIG ( CP_OFF & LVP_OFF & BOREN_ON & MCLRE_ON & PWRTE_ON & WDTE_OFF & FOSC_INTOSCIO );
#pragma config CPD=OFF , LVP=OFF , BOREN=ON , MCLRE=ON , PWRTE=ON , WDTE=OFF , FOSC=INTOSCIO

/*
	vg^Cv錾
 */
void set7Seg( unsigned int num, unsigned int id );		// idŎw肵7SEG LEDɐ\
void dispTime( void );									// \
void setTime( void );									// ݒ



/*
	}N`
 */

#define	CCPR1_VAL		1000L	// 1mbƂɊޏꍇCCPR1ɑl

#define	STATE_SET_TIM	0		// ݒ
#define	STATE_CLOCK		1		// v

#define	SW_MIN			RA0		// ""킹pSW
#define	SW_HOUR			RA1		// ""킹pSW
#define	SW_START		RA2		// START SW

#define	SW_ON			0
#define	SW_OFF			1



/*
 	O[oϐ
 */
unsigned int g_ms   = 0;					// o "mb" i[
unsigned int g_sec  = 0;					// o "b"  i[
unsigned int g_min  = 0;					// o ""  i[
unsigned int g_hour = 0;					// o ""  i[

unsigned int g_state;						// vOԕϐ



/*
	main
 */
void main( void ){

	/*	|[g	*/	
	CMCON = 0x07;						// RA0`RA3 <- IO
	PORTB = 0x00;						// PORTB    <- Lx
	TRISB = 0x00;						// PORTB    <- outport
	TRISA = 0b00100111;					// RA0`RA2 <- inport


	/*	CCPݏ 1msƂɊ	*/
	CCP1CON = 0b00001011;				// CCP݃[h
	CCPR1H  = ( CCPR1_VAL >> 8 );		// CCPR1H <- CCPR1_VAL̏8rbg
	CCPR1L  = ( CCPR1_VAL & 0x00FF );	// CCPR1L <- CCPR1_VAL̉8rbg

	CCP1IF  = 0;						// CCP݃tONA
	CCP1IE  = 1;						// CCP݂̋

	
	/*	Timer1	*/
	TMR1ON  = 0;						// Timer1 Stop
	TMR1CS  = 0;						// NbNNbNɐݒ
	
	T1CKPS1 = 0;						// /1
	T1CKPS0 = 0;

	TMR1H   = 0;							// TMRWX^NA
	TMR1L   = 0;
	
	/*	݋	*/
	PEIE = 1;							// Ӌ@\݋
	GIE  = 1;							// ݑS̋


	g_state = STATE_SET_TIM;			// vOԕϐ <- ݒ

	while(1){

		// vOԕϐg_stateɂ菈
		switch ( g_state ){
			
			// ݒ
			case STATE_SET_TIM:{
				
				// START SWꂽꍇ
				if( SW_START == SW_ON ){
						TMR1ON = 1;					// Timer1 Start
						g_state = STATE_CLOCK;		// "v"ɑJ
				}
				else{
					setTime();						// ݒ
				}
				
				break;
			}
			
			// v
			case STATE_CLOCK:{
				/*
					uSW玞v~vȂǂ̏ǉꍇ́C
					ɋLq
				 */
				break;
			}
		}
		dispTime();		// ̕\
	}
	
}

	


/*
	117SEGɐZbg

	
		num : Zbg鐔 ( l )
		id	: 0 -> "" 2
		      1 -> "" 1
		      2 -> "" 2
		      3 -> "" 1
*/
void set7Seg( unsigned int num, unsigned int id ){

	PORTB = ( ( 0b00001000 >> id ) | ( num << 4 ) );
}	

/*
	\
 */
void dispTime( void ){

	set7Seg( g_hour / 10, 0 );		// "" 2 \
	set7Seg( g_hour % 10, 1 );		// "" 1 \

	set7Seg(  g_min / 10, 2 );		// "" 2 \
	set7Seg(  g_min % 10, 3 );		// "" 1 \

}


/*
	ݒ
 */
void setTime( void ){
	
	static int cnt = 0;		// AĎύXsȂ悤ɒ邽߂̕ϐ
	
	// AĎύXsȂ悤ɕϐcntŒ
	if( cnt < 1 ){

		// ""킹pSWꂽꍇ
		if( SW_MIN == SW_ON ){
			g_min++;					// "" + 1

			if( g_min > 59 ){
				g_min=0;				// "60"̏ꍇ"0"ɖ߂
			}
			cnt = 100;
		}

		// ""킹pSWꂽꍇ
		if( SW_HOUR == SW_ON ){
			g_hour++;					// "" + 1
						
			if( g_hour > 23 ){
				g_hour = 0;				// "24"̏ꍇ"0"ɖ߂
			}

			cnt = 100;
		}
	}
	else{
		cnt--;							// AĎύXsȂ悤ɕϐcntŒ
	}
}	


/*
	݃T[rX[`
		1mbƂCCP
 */
static void __interrupt() isr(void){

	g_ms++;					// "mb" +1

	// 1bo
	if ( g_ms >= 1000 ){
		g_sec++;
		g_ms = 0;
	}

	// 1o
	if ( g_sec >= 60 ){
		g_min++;
		g_sec = 0;
	}
	
	// 1Ԍo
	if ( g_min >= 60 ){
		g_hour++;
		g_min = 0;
	}	
	
	// 24Ԍo
	if ( g_hour >= 24 ){
		g_hour = 0;
	}	

	CCP1IF = 0;	// CCP݃tONA
}


